/* Algarvu-Scrabble*/
#include <map>
#include <cstdio>
#include <cmath>
#include <iostream>
using namespace std;

#define SP 9000000

std::map<int, int> acache;

std::map<int, int> pyga;

char soel[SP]; //algarvude jada

void alg() {
    int i, j;
    for (i = 0; i < SP; i++)
        soel[i] = 1; // alguses paneme kik algarvudeks
    soel[0] = 0; // 0 ei ole algarv
    soel[1] = 0; // 1 ei ole algarv
    for (i = 2; i * i < SP; i++) {
        if (soel[i] == 1)
            for (j = i * i; j < SP; j += i)
                soel[j] = 0;
    }
}

int parim = -99999;
int p_pikkus;
int p_kaigud[12];
int p_pk[12];
int p_trahv;
int kaigud[12];
int pk[12];

int kaes[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int trahv;

std::map<int, int> suuredArvud; // pikemate arvude kohta algarvulisuse info hoidmine

int onalgarv(int p) {
    int i;
    if (p < SP) // kui kontrollitav arv selas
        return soel[p]; // tagastame sealt info: 1 kui on algarv, 0 kui ei ole

    if (suuredArvud.find(p) == suuredArvud.end()) { // kui ei ole veel kontrollinud
        for (i = 2; i <= sqrt(p); i++) {
            if ((i < SP) && (soel[i] == 0)) // i on selas ja i on kordarv
                continue; // vtame jrgmise arvu
            if (p % i == 0) { // kui p jagub i-ga
                suuredArvud[p] = 0; // lisame map'i, et p on kordarv
                return 0;
            }
        }
        suuredArvud[p] = 1; // p ei jagunud millegagi, lisame map'i, et p on algarv
    }
    return suuredArvud[p]; // tagastame salvestatud info mapist
}


// pikkus - lauale pandud kivide arv
// punktid - enne viimast kivi saadud punktid
// vasak - laual olev arv vasakult paremale lugedes
// parem - laual olev arv paremalt vasakule lugedes
// mask - kmne aste, mis vastab laual olevale kivide arvule
void otsi(int pikkus, int punktid, int laual, int vasak, int parem, int mask) {
    int i;
    if (pikkus > 0) {
        kaigud[pikkus - 1] = vasak;

        if (onalgarv(vasak)) {
            punktid += laual;
        }

        if (onalgarv(parem)) {
            punktid += laual;
        }
        pk[pikkus - 1] = punktid;
    }

    if ((mask == 0) || onalgarv(vasak) || onalgarv(parem)) {
        int voimalik = punktid - trahv + laual;
        if (parim < voimalik) {
            parim = voimalik;
            p_pikkus = pikkus;
            for (i = 0; i < pikkus; i++) {
                p_kaigud[i] = kaigud[i];
                p_pk[i] = pk[i];
            }
            p_trahv = laual - trahv;
        }
    }

    int max_arv = (vasak > parem) ? vasak : parem;
    if (pyga.find(max_arv) == pyga.end()) {
        // sellist arvu pole varem olnud, salvestame
        pyga[max_arv] = punktid;
    }
    else {
        // selline arv on varem olnud 
        if (pyga[max_arv] >= punktid)
            // ja andis rohkem punkte, edasi pole mtet uurida
            return;
    }

    // proovime kiki kive alates suuremast, sest see annab heuristiliselt rohkem punkte
    for (i = 9; i >= 0; i--) {
        if (kaes[i] > 0)  {
            kaes[i]--;

            if (mask == 0)	{
                otsi(pikkus + 1, punktid, laual + i, i, i, 1);
            }
            else {
                int uusmask = 10 * mask;
                // vasakule lisamine
                otsi(pikkus + 1, punktid, laual + i, uusmask * i + vasak, parem * 10 + i, uusmask);
                if (vasak != parem) {
                    // paremale lisamine
                    otsi(pikkus + 1, punktid, laual + i, vasak * 10 + i, uusmask * i + parem, uusmask);
                }
            }

            kaes[i]++;  // kivi laualt ktte tagasi
        }
    }
}

int main() {

    int n, i, k;
    cin >> n;
    for (i = 0; i < n; i++) {
        cin >> k;
        kaes[k]++;
        trahv += k;
    }

    alg();
    otsi(0, 0, 0, 0, 0, 0);

    cout << p_pikkus << " " << parim << endl;
    for (i = 0; i < p_pikkus; i++) {
        cout << p_kaigud[i] << " " << p_pk[i] << endl;
    }
    cout << p_trahv << endl;
    return 0;
}
