# coding: utf-8

# 2016-11-19 programmeerimisvõistlus
# Ülesanne: ALGARVU-SCRABBLE (põhikooli variant)
# Autor: Ahto Truu

# Lihtne lahendus, mis proovib juhuslikke mänge ja kui aeg hakkab
# otsa saama, väljastab parima leitud variandi

import random
import time


# leiab kivijada a summa
def summa(a):
    n = 0
    for x in a:
        n = n + int(x)
    return n


# kontrollib, kas kivijada a on algarv
def algarv(a):
    # kõigepealt leiame jada esitatava arvu väärtuse
    n = 0
    for x in a:
        n = 10 * n + x
    # nüüd kontrollime, kas see on algarv
    if n < 2:
        return False
    i = 2
    while i * i <= n:
        if n % i == 0:
            return False
        i = i + 1
    return True


# globaalsed muutujad parima leitud lahenduse hoidmiseks
# parim_plaan on käigujada, kus iga käik on paar
# (kivi, 0/1 == vasakule/paremale)
parim_summa = -100
parim_plaan = []


# proovib panna kivid lauale jadas p näidatud järjekorras
# iga kivi paneme seisule juurde kas vasakule või paremale
def hinda(p):
    global parim_summa, parim_plaan
    plaan = []
    a = []
    s, t, k = 0, 0, 0
    for x in p:
        # valime juhuslikult, kas lisame vasakule või paremale
        r = random.randrange(2)
        plaan.append((x, r))
        if r == 0:
            a = [x] + a
        else:
            a = a + [x]
        t = t + x
        k = k + 1
        if algarv(a):
            s = s + summa(a)
            t, k = 0, 0
        if algarv(reversed(a)):
            s = s + summa(a)
            t, k = 0, 0
    if parim_summa < s - t:
        parim_summa = s - t
        parim_plaan = plaan[: len(plaan) - k]


#
# põhiprogrammi algus
#

n = int(input().strip())
a = map(int, input().strip().split())

t = time.clock() + 9.5
while time.clock() < t:
    random.shuffle(a)
    hinda(a)

print('{0} {1}\n'.format(len(parim_plaan), parim_summa))
s = 0
a = []
for (x, k) in parim_plaan:
    if k == 0:
        a = [x] + a
    else:
        a = a + [x]
    if algarv(a):
        s = s + summa(a)
    if algarv(reversed(a)):
        s = s + summa(a)
    print('{0} {1}\n'.format(''.join(map(str, a)), s))
print('{0}\n'.format(parim_summa - s))
