/* Algteguriteks lahutamine */
#include <vector>
#include <iostream>
using namespace std;

// Eratosthenese sel
const int SP = 1000000; // sela pikkus
char soel[SP]; // algarvude jada

void alg() {
    int i, j;
    for (i = 0; i < SP; i++)
        soel[i] = 1; // alguses paneme kik algarvudeks
    soel[0] = 0; // 0 ei ole algarv
    soel[1] = 0; // 1 ei ole algarv
    for (i = 2; i * i <= SP; i++) {
        if (soel[i] == 1)
            for (j = i * i; j < SP; j += i)
                soel[j] = 0;
    }
}

// Arvu algtegurite leidmine
vector <long long> algtegurid(long long n){
    vector <long long> tegurid; // siin hoiame vastust
    int aa = 1; // jrgmine algarv, millega jagame
    while (++aa < SP){ // otsime selast
        if (!soel[aa]) continue; // kui ei ole algarv, vtame jrgmise
        if (aa*aa > n) break; // kui teguri ruut on suurem kui n, siis lpetame
        while (n % aa == 0) { // kuni jagub vaadeldava algarvuga
            tegurid.push_back(aa); // kirjutame selle algarvu tegurite massiivi
            n /= aa; // jagame n-i lbi
        }
    }
    if (n != 1) tegurid.push_back(n); // kui meil midagi jrele ji, siis ehk algarv
    return tegurid;
}

int main()
{
    alg(); // tidab sela

    vector<long long> r = algtegurid(2147483647);
    for (vector<long long>::iterator i = r.begin(); i != r.end(); i++) {
        cout << *i << " ";
    }
    cout << endl;

    r = algtegurid(136117223861LL);
    for (vector<long long>::iterator i = r.begin(); i != r.end(); i++) {
        cout << *i << " ";
    }
    cout << endl;

    r = algtegurid(142391208960LL);
    for (vector<long long>::iterator i = r.begin(); i != r.end(); i++) {
        cout << *i << " ";
    }
    cout << endl;
    return 0;
}