/* Suurte arvudega arvutamine.
Anagrammid suurte arvudega*/

#include <iostream>
#include <string>
#include <algorithm>

using namespace std;
typedef struct {
    char numbrid[10000];
    int mark;
    int pikkus;
} suurarv;

suurarv lahuta(suurarv *a, suurarv *b);
int vordle(suurarv *a, suurarv *b);
suurarv stringSuurArvuks(string s);
void nihuta(suurarv *n, int d);
void kirjuta(suurarv *a);
void eemaldaNullid(suurarv *a);
suurarv int_suurarvuks(int s);
suurarv liida(suurarv *a, suurarv *b);
suurarv korruta(suurarv *a, suurarv *b);
suurarv jaga(suurarv *a, suurarv *b);
suurarv astenda(suurarv a, int n);
suurarv faktoriaal(int n);

suurarv stringSuurArvuks(string s) {
    suurarv vastus;
    vastus.mark = 1;
    vastus.pikkus = s.length();
    int i = 0;
    if (s[0] == '-') {
        vastus.mark = -1;
        i++;
    }
    for (i; i < s.length(); i++)
        vastus.numbrid[vastus.pikkus - 1 - i] = s[i] - '0';
    if (vastus.mark == -1)
        vastus.pikkus--;

    return vastus;
}

void nihuta(suurarv *n, int d) {
    int i;
    if ((n->pikkus == 1) && (n->numbrid[0] == 0)) {
        return;
    }
    for (i = n->pikkus; i >= 0; i--) {
        n->numbrid[i + d] = n->numbrid[i];
    }
    for (i = 0; i < d; i++) {
        n->numbrid[i] = 0;
    }
    n->pikkus = n->pikkus + d;
}

void kirjuta(suurarv *a) {
    if (a->mark == -1)
        cout << '-';
    for (int i = a->pikkus; i > 0; i--)
        cout << (char)('0' + a->numbrid[i - 1]);
    cout << endl;
}

void eemaldaNullid(suurarv *a)
{
    while ((a->pikkus > 1) && (a->numbrid[a->pikkus - 1] == 0))
        a->pikkus--;
    if ((a->pikkus == 1) && (a->numbrid[0] == 0))
        a->mark = 1;
}

suurarv int_suurarvuks(int s) {
    suurarv n = { { 0 }, 1, 1 };
    int i;
    int t;
    if (s >= 0) {
        n.mark = 1;
    }
    else {
        n.mark = -1;
    }

    n.pikkus = 0;
    t = abs(s);
    while (t > 0) {
        n.pikkus++;
        n.numbrid[n.pikkus-1] = (t % 10);
        t = t / 10;
    }
    if (s == 0) {
        n.pikkus = 1;
    }
    return n;
}

suurarv liida(suurarv *a, suurarv *b) {
    int ylekanne = 0;
    int i;
    suurarv vastus = { { 0 }, 1, 1 };

    if (a->mark == b->mark) vastus.mark = a->mark; //kui liidetavad on samamrgilised, on vastus ka sama mrgiga
    else {
        if (a->mark == -1) { //kui a on negatiivne, lahutame b-st a absoluutvrtuse
            a->mark = 1;
            vastus = lahuta(b, a);
            a->mark = -1;
        }
        else { //kui b on negatiivne, lahutame a-st b absoluutvrtuse
            b->mark = 1;
            vastus = lahuta(a, b);
            b->mark = -1;
        }
        return vastus; //vastus ongi kes
    }

    //vastus saab kahe liidetava korral olla maksimaalselt he koha vrra pikem, kui pikem liidetav
    vastus.pikkus = max(a->pikkus, b->pikkus) + 1;
    for (i = 0; i < vastus.pikkus; i++) {
        int summa = (ylekanne + a->numbrid[i] + b->numbrid[i]);
        vastus.numbrid[i] = (char)summa % 10;
        ylekanne = summa / 10;
    }

    eemaldaNullid(&vastus);
    return vastus;
}

suurarv lahuta(suurarv *a, suurarv *b) {
    suurarv vastus = { { 0 }, 1, 1 };
    int laen;

    if ((a->mark == -1) || (b->mark == -1)) //kui ks on negatiivne
    {
        b->mark *= -1;
        vastus = liida(a, b);
        b->mark *= -1;
    }

    if (vordle(a, b) == 1) { // kui a on b-st viksem
        lahuta(b, a);
        vastus.mark = -1;
    }
    vastus.pikkus = max(a->pikkus, b->pikkus);
    laen = 0;
    for (int i = 0; i <= vastus.pikkus; i++) {
        int v = a->numbrid[i] - laen - b->numbrid[i];
        if (a->numbrid[i] < 0) {
            laen = 0;
        }
        if (v < 0) {
            v += 10;
            laen = 1;
        }
        vastus.numbrid[i] = (char)v % 10;
    }
    eemaldaNullid(&vastus);
    return vastus;
}

int vordle(suurarv *a, suurarv *b) {
    if (a->mark != b->mark) // kui mrgid on erinevad
        return b->mark;
    if (a->pikkus != b->pikkus) //kui kohtade arv on erinev
        return (a->pikkus < b->pikkus) ? (1 * a->mark) : (-1 * a->mark);

    for (int i = a->pikkus - 1; i <= 0; i--) {
        if (a->numbrid[i] > b->numbrid[i]) {
            return -1 * a->mark;
        }
        if (b->numbrid[i] > a->numbrid[i]) {
            return 1 * a->mark;
        }
    }
    return 0;
}

suurarv korruta(suurarv *a, suurarv *b) {
    suurarv vastus = { { 0 }, 1, 1 };
    suurarv rida; //vahetulemuse meelespidamiseks

    rida = *a;
    for (int i = 0; i < b->pikkus; i++) {
        for (int j = 0; j < b->numbrid[i]; j++) {
            vastus = liida(&rida, &vastus);
        }
        nihuta(&rida, 1); //korrutame 10ga
    }
    vastus.mark = a->mark*b->mark;
    eemaldaNullid(&vastus);
    return vastus;
}

suurarv jaga(suurarv *a, suurarv *b) {
    suurarv rida = { { 0 }, 1, 0 };
    suurarv tmp;
    suurarv vastus = { { 0 }, 1, 1 };
    int amark, bmark;
    int i;
    vastus.mark = a->mark * b->mark;
    amark = a->mark;
    bmark = b->mark;
    a->mark = 1;
    b->mark = 1;
    vastus.pikkus = a->pikkus;
    for (i = a->pikkus - 1; i >= 0; i--) {
        nihuta(&rida, 1);
        rida.numbrid[0] = a->numbrid[i];
        vastus.numbrid[i] = 0;
        while (vordle(&rida, b) != 1) {
            vastus.numbrid[i]++;
            tmp = lahuta(&rida, b);
            rida = tmp;
        }
    }
    eemaldaNullid(&vastus);
    a->mark = amark;
    b->mark = bmark;

    return vastus;
}

suurarv astenda(suurarv a, int n) {
    suurarv k = a;
    suurarv vastus = { { 1 }, 1, 1 };

    for (int i = n; i > 0; i = i / 2) {
        if (i % 2 == 1)
            vastus = korruta(&vastus, &k);
        k = korruta(&k, &k);
    }
    return vastus;
}

suurarv faktoriaal(int n)
{
    suurarv vastus = { { 1 }, 1, 1 };

    for (int i = 2; i <= n; i++) {
        vastus = korruta(&vastus, &(int_suurarvuks(i)));
    }

    return vastus;
}

int main ()
{
    int n;
    cin >> n;
    int m[1000];
    int i, j = 1, a;
    suurarv total;
    total.mark = 1;
    total.pikkus = 1;
    total.numbrid[0] = 1;
    for (i = 0; i < n; i++) {
        cin >> m[i];
    }
    sort(m, m + n);
    reverse(m, m + n);
    for (i = 0; i < n; i++) {
        int k = j + m[i];
        suurarv f = { { 1 }, 1, 1 }; // kasutame omaloodud tpi
        suurarv f2 = faktoriaal(m[i]);
        for (a = j; a < k; a++) {
            suurarv b = int_suurarvuks(a);
            f = korruta(&f, &b);
        }
        suurarv t = jaga(&f, &f2);
        total = korruta(&total, &t);
        j = k;
    }
    kirjuta(&total);
    return 0;
}