/* Positsioonilised arvussteemid*/
#include <iostream>
#include <string>
#include <assert.h>

using namespace std;
typedef long long ll;

double EPS = 1e-20;

// Leiab leitavast kohast lejva osa lubatava maksimaalse ja minimaalse vrtuse
void leiaJaagid(double astendatudalus, double min_kordaja, double max_kordaja, double* min_jaak, double* max_jaak)
{
    if (!(astendatudalus < 0LL)){
        *min_jaak = astendatudalus*min_kordaja - EPS;
        *max_jaak = astendatudalus*max_kordaja + EPS;
    }
    else{ // negatiivsel alusel kui on paarituarvuline aste, siis max ja min on vahetuses
        *min_jaak = astendatudalus*max_kordaja - EPS;
        *max_jaak = astendatudalus*min_kordaja + EPS;
    }
}

// Leiab "jrgmise" numbri ehk esimese numbri jrelejnud teisendatavast osast
char leiaNumber(double* vaartus, double astendatudalus, int numbrite_arv, double min_kordaja, double max_kordaja)
{
    char number;
    double kontroll = *vaartus;
    bool leitud = false;
    double jrgm_min_jaak, jrgm_max_jaak;
    leiaJaagid(astendatudalus, min_kordaja, max_kordaja, &jrgm_min_jaak, &jrgm_max_jaak);

    // proovime, milline saaks olla jrgmine leitav number
    for (number = 0; number < numbrite_arv; ++number) {
        if (kontroll > jrgm_min_jaak && kontroll < jrgm_max_jaak) {
            leitud = true;
            *vaartus = kontroll; // vrtus saab vrdseks teisendamata osaga
            break;
        }
        kontroll = kontroll - astendatudalus; // eelmine number ei sobinud, suurema numbri proovimisel vhendame jki
    }
    return '0' + number;
}

// Keerab stringi mber ja nihutab koma igesse kohta
void keera(string* vastus)
{
    if (vastus->find(".") == string::npos) { // ja tulemuses koma ei ole
        *vastus = *vastus + ".0"; // lisame ".0" vastuse lppu
    }
    int koma_asukoht = vastus->find(".");
    swap((*vastus)[koma_asukoht - 1], (*vastus)[koma_asukoht]); // nihutame koma stringis vasakule, sest see kuulub selle arvu juurde, mille jrel ta on nt 123. on tegelikult 1 2 ja 3., keerates tahame saada 3.21
    reverse(vastus->begin(), vastus->end()); // ja keerame vastuse mber
}

// Eemaldab nullid arvu eest ja lpust, vajadusel eemaldab ka koma lpust.
void normaliseeri(string* vastus)
{
    while (vastus->back() == '0'){ //eemaldame nullid murdosa lpust
        vastus->pop_back();
    }
    if (vastus->back() == '.'){ //eemaldame koma (tis)arvu lpust
        vastus->pop_back();
    }
    while (vastus->size() >= 2 && (*vastus)[0] == '0' && (*vastus)[1] != '.'){ // eemaldame nullid algusest
        *vastus = vastus->substr(1);
    }
}

string teisenda(double vaartus, double alus)
{
    string vastus = "";
    int numbrite_arv = 0; // ssteemis kasutatavate numbrite ehk mrkide arv
    double astendatudalus = 1LL; // aluse aste, mida ttleme
    bool alus_vahetatud = false;
    if (abs(alus) < 1){
        alus = 1LL / alus;
        alus_vahetatud = true;
    }

    while (double(numbrite_arv) < abs(alus) - EPS){
        ++numbrite_arv; // suurendame, kuni on vhemalt aluse absoluutvtusega vrdne
    }

    int ennekoma = 0; // kohtade arv enne koma uues ssteemis
    while (!(vaartus < astendatudalus)){
        astendatudalus *= alus;
        ++ennekoma;
    }

    double min_kordaja = 0LL;
    double max_kordaja = 0LL;
    if (alus > 0LL){ // kui alus on positiivne
        max_kordaja = double(numbrite_arv - 1) / (alus - 1);
    }
    else{
        max_kordaja = double(numbrite_arv - 1) / (alus*alus - 1);
        min_kordaja = max_kordaja*alus;
    }

    while (vastus.size() < 990 && abs(vaartus) > EPS*double(10LL)) {
        vastus += leiaNumber(&vaartus, astendatudalus, numbrite_arv, min_kordaja, max_kordaja);
        astendatudalus /= alus;
        if (ennekoma == 0) vastus += '.';
        --ennekoma;
    }

    if (alus_vahetatud)  // kui alus oli 0 ja 1 vahel
        keera(&vastus);
    normaliseeri(&vastus);

    return vastus;
}

int main()
{
    double vaartus;
    double alus;
    cin >> vaartus >> alus;
    cout << teisenda(vaartus, alus);

    return 0;
}