// Naturaalarvude teisendamine positsioonilisse arvussteemi tisarvulisel alusel
#include <iostream>
#include <string>
using namespace std;

//Teisendamine antud alusel arvussteemi paremalt vasakule
string arvAlusele(unsigned int n, unsigned int alus) {
    string s = ""; // vastus
    if (n == 0) return "0";
    while (n) {
        int d = n % alus; // jrgmise koha vrtus
        // Teisendame selle mrgiks, esimesed on 0..9, edasi A..
        s += (char)(d < 10) ? '0' + d : 'A' + d - 10;
        n /= alus; // vhendame n
    }
    reverse(s.begin(), s.end()); // tegime paremalt vasakule, keerame mber
    return s;
}

//Teisendamine antud alusel arvussteemi vasakult paremale
string arvAlusele2(unsigned int n, char alus) {
    string s = ""; // vastus
    unsigned int aste = alus; // astendatud alus
    while (n > aste){
        aste *= alus; // otsime suurima astme
    }
    aste /= alus; // lksime 1 astme mda, jagame alusega
    while (aste) {
        int d = n / aste; // jrgmise koha vrtus
        // Teisendame selle mrgiks, esimesed on 0..9, edasi A..
        s += (char)(d < 10) ? '0' + d : 'A' + d - 10;
        n %= aste; // lejnud kohad
        aste /= alus; // vhendame kordset
    }
    return s;
}

int main()
{
    cout << arvAlusele(20, 2) << endl;
    cout << arvAlusele(20, 16) << endl;
    cout << arvAlusele(695, 16) << endl;

    cout << arvAlusele2(20, 2) << endl;
    cout << arvAlusele2(20, 16) << endl;
    cout << arvAlusele2(695, 16) << endl;

    return 0;
}
