#include <algorithm>
#include <iomanip>
#include <iostream>

using namespace std;

int jagaKingid(int La, int Lb, int Lc, int Ka, int Kb, int Kc, int N, int* kingid)
{
    double**** kv = new double***[La + 1]; //1. lastekodust kohalolevate laste arv
    for (int i = 0; i <= La; i++) {
        kv[i] = new double**[Lb + 1]; //2. lastekodust kohalolevate laste arv
        for (int j = 0; j <= Lb; j++) {
            kv[i][j] = new double*[Lc + 1]; //3. lastekodust kohalolevate laste arv
            for (int k = 0; k <= Lc; k++) {
                kv[i][j][k] = new double[3]; // lastekodu
            }
        }
    }

    int lapsiKokku = La + Lb + Lc;
    //Alustame sellest, kui kik lapsed on lahkunud kuni selleni, kui kik veel alles 
    for (int al = lapsiKokku - N; al <= lapsiKokku; al++) {
        int m1 = min(La, al);//nii palju saab maksimaalselt olla alles 1. lastekodust
        for (int i = 0; i <= m1; i++) {
            //nii palju saab olla 2. lastekodust, kui esimesest on alles i last:
            int m2 = min(Lb, al - i);
            for (int j = 0; j <= m2; j++) {
                if (al - i - j <= Lc) {
                    int k = al - i - j; //nii palju on 3. lastekodust kohal
                    kv[i][j][k][0] = 0;
                    kv[i][j][k][1] = 0;
                    kv[i][j][k][2] = 0;
                    if (al == lapsiKokku - N) {
                        continue; //kedagi ei ole, jtkame
                    }
                    double p1 = i * Ka;
                    double p2 = j * Kb;
                    double p3 = k * Kc;
                    double kp = p1 + p2 + p3; //alles korvide kogupindala
                    double t1 = p1 / kp; //Tenosus, et kingi saab 1. lastekodu
                    double t2 = p2 / kp; //2. lastekodu
                    double t3 = p3 / kp; //3. lastekodu
                    int jk = kingid[lapsiKokku - al]; //jagatava kingi vrtus

                    if (i != 0) {
                        kv[i][j][k][0] += t1 * (jk + kv[i - 1][j][k][0]);
                        kv[i][j][k][1] += t1 * kv[i - 1][j][k][1];
                        kv[i][j][k][2] += t1 * kv[i - 1][j][k][2];
                    }
                    if (j != 0) {
                        kv[i][j][k][0] += t2 * kv[i][j - 1][k][0];
                        kv[i][j][k][1] += t2 * (jk + kv[i][j - 1][k][1]);
                        kv[i][j][k][2] += t2 * kv[i][j - 1][k][2];
                    }
                    if (k != 0) {
                        kv[i][j][k][0] += t3 * kv[i][j][k - 1][0];
                        kv[i][j][k][1] += t3 * kv[i][j][k - 1][1];
                        kv[i][j][k][2] += t3 * (jk + kv[i][j][k - 1][2]);
                    }
                }
            }
        }
    }

    cout << fixed << setprecision(10) << kv[La][Lb][Lc][0] << endl <<
        kv[La][Lb][Lc][1] << endl << kv[La][Lb][Lc][2] << endl;
    return 0;
}


int main()
{
    int La, Lb, Lc, Ka, Kb, Kc, N;
    //sisend: 
    //esimese lastekodu laste arv
    //esimese lastekodu korvi pindala
    //teise lastekodu laste arv
    //teise lastekodu korvi pindala
    //kolmanda lastekodu laste arv
    //kolmanda lastekodu korvi pindala
    cin >> La >> Ka >> Lb >> Kb >> Lc >> Kc;
    cin >> N; //kinkide arv
    int* kingid = new int[N];
    for (int i = 0; i < N; i++) {
        cin >> kingid[i]; //kinkide vrtused
    }

    jagaKingid(La, Lb, Lc, Ka, Kb, Kc, N, kingid);
    return 0;
}
