#include <iostream>
#include <iomanip>

using namespace std;

double leiaFeim(int N, int* moevaartused, int* pikkused)
{
    // vimalike kombinatsioonide arv, millised sallid vivad sdud olla = 2^n
    int kombinatsioonid = 1 << N;
    int kogupikkus = 0;
    for (int i = 0; i < N; i++) {
        kogupikkus += pikkused[i];
    }
    // Siin massiivis hoiame parimaid vimalikke tulemusi, mida on vimalik saavutada,
    // kui meil on alles mingi konkreetne kombinatsioon salle.
    // Massiivi indeksid vastavad sallikombinatsioonide kahendarvulistele vrtustele.
    // Niteks feimid[37] sisaldab maksimaalset vimalikku vrtust, mida Mrdil on 
    // vimalik saavutada juhul, kui alles on 1, 3 ja 6 sall (sest 10-ssteemis 37 on
    // kahendssteemis 00100101, seatud on altpoolt lugedes 1, 3 ja 6 bitt)
    double* feimid = new double[kombinatsioonid];
    feimid[0] = 0;
    // konstrueerime kik kombinatsioonid alates lihtsamatest
    for (int i = 1; i < kombinatsioonid; i++) {
        feimid[i] = 0;

        // Proovime uue kombinatsiooni les ehitada viksematest.
        // mvalik on Mrdi tehtav valik, st mitmenda salli ta vtab.
        // Proovime kiki Mrdi valikuid
        for (int mvalik = 0, mbit = 1; mbit <= i; mbit *= 2, mvalik++) {
            // bitt pole seatud, st vaadeldav kombinatsioon ei sisalda seda salli
            if ((mbit & i) == 0){
                continue;
            }
            double alles = 1;  // tenosus, et htki head salli ei sda ra
            double feim = moevaartused[mvalik];  // Mrdi kigu vrtus
            // kvalik on Krdi tehtav valik, st mitmendale sallile ta augu sb
            for (int kvalik = 0, kbit = 1; kbit <= i; kbit *= 2, kvalik++) {
                if ((i & kbit) == 0 || mvalik == kvalik) continue;
                double prob = (double)pikkused[kvalik] / kogupikkus;
                // vrtusele lisandub selle allesjva kombinatsiooni vrtus, kust 
                //on eemaldatud Mrdi ja Krdi sall
                feim += prob * feimid[i ^ mbit ^ kbit];
                alles -= prob;
            }
            // Kui Krt ei snud htki head salli ra, lisandub selle kombinatsiooni
            // vrtus, kus on kik sallid peale Mrdi praeguse valiku
            feim += alles * (feimid[i ^ mbit]);
            if (feim > feimid[i]) {
                feimid[i] = feim;
            }
        }
    }
    return feimid[kombinatsioonid - 1];
}
    
int main()
{
    int N;
    cin >> N; // sallide arv
    int* moevaartused = new int[N];
    int* pikkused = new int [N];
    for (int i = 0; i < N; i++) {
        cin >> pikkused[i]; //salli pikkus
        cin >> moevaartused[i]; //salli moevrtus
    }
    
    cout << fixed << showpoint;
    cout << setprecision(6);
    cout << leiaFeim(N, moevaartused, pikkused) << endl;
    return 0;
}