#include <iostream>

using namespace std;

int LeiaVahe(int mituPakki, int* pakid)
{
    int suurimVahe = 0;
    for (int i = 0; i < mituPakki; i++) {
        suurimVahe += pakid[i]; //Leiame suurima vimaliku vahe
    }
    bool** tabel = new bool*[suurimVahe + 1];
    for (int i = 0; i <= suurimVahe; i++) {
        tabel[i] = new bool[2];//kokkuhoidliku DP jaoks on vaja vaid 2 rida
    }
    tabel[0][1] = 1; //kui midagi jagada pole, on vahe 0
    for (int i = 1; i <= suurimVahe; i++) {
        tabel[i][1] = 0; //lejnud vahed on vimatud
    }
    for (int i = 0; i < mituPakki; i++) {
        int praeguneRida = i % 2;
        int eelmineRida = (i + 1) % 2;
        for (int j = 0; j < suurimVahe; j++) {
            int eelmineVahe = j - pakid[i];
            if (eelmineVahe < 0){
                eelmineVahe = -eelmineVahe;
            }
            if (tabel[eelmineVahe][eelmineRida]) {
                tabel[j][praeguneRida] = 1;
                continue;
            }
            eelmineVahe = j + pakid[i];
            if (eelmineVahe > suurimVahe || !tabel[eelmineVahe][eelmineRida]) {
                tabel[j][praeguneRida] = 0;
                continue;
            }
            tabel[j][praeguneRida] = 1;
        }
    }
    int vastus;
    for (int i = 0; i < suurimVahe; i++) {
        int praeguneRida = (mituPakki - 1) % 2;
        if (tabel[i][praeguneRida]) {
            vastus = i; //leiame esimese vimaliku vahe, see ongi vastuseks
            break;
        }
    }
    return vastus;
}

int main()
{
    int N;
    cin >> N; //kinkide arv
    int* pakid = new int[N];
    for (int i = 0; i < N; i++) {
        cin >> pakid[i]; //kingi vrtus
    }
    cout << LeiaVahe(N, pakid) << endl;
    return 0;
}


