#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
#define MAXINT 2147483647
int kaugus(int a, int b) {
    return abs(a-b);
}

int DTW(int n, int m, vector<int> s, vector<int> t)
{
    int** dp = new int*[n+1];
    for (int i = 0; i <= n; i++) {
        dp[i] = new int[m + 1];
    }

    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= m; j++) {
            dp[i][j] = MAXINT;
        }
    }

    dp[0][0] = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            dp[i][j] = min(min(dp[i - 1][j], dp[i][j - 1]), dp[i - 1][j - 1])
                + kaugus(s[i - 1], t[j - 1]);
        }
    }
    return dp[n][m];
}

int main()
{
    int m, n;
    cin >> m;
    vector<int> s(m,0);
    for (int i = 0; i < m; i++) {
        cin >> s[i];
    }

    cin >> n;
    vector<int> t(n,0);
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }

    cout << DTW(m, n, s, t) << endl;
    cin >> n;
    return 0;
}