#include <algorithm>
#include <iostream>

using namespace std;
int LevenshteinDistance(int n, int m, string s, string t)
{
    int** dp = new int*[n + 1];
    for (int i = 0; i <= n; i++)
    {
        dp[i] = new int[m + 1];
        for (int j = 0; j <= m; j++)
        {
            dp[i][j] = 0;
        }
    }
    for (int i = 0; i <= n; i++)
    {
        dp[i][0] = i;
    }
    for (int i = 0; i <= m; i++)
    {
        dp[0][i] = i;
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            int sc = 1;
            if (s[i-1] == t[j-1])
            {
                sc = 0;
            }
            dp[i][j] = min(min(dp[i - 1][j] + 1, dp[i][j - 1] + 1), dp[i - 1][j - 1] + sc);
        }
    }

    return dp[n][m];
}

int main()
{
    int n, m;
    cin >> n >> m;
    string s, t;
    cin >> s;
    cin >> t;

    int vastus = LevenshteinDistance(n, m, s, t);
    cout << vastus << endl;
    return 0;
}

